SystemOrganization addCategory: #'Ma traverse object graphs-API'!
SystemOrganization addCategory: #'Ma traverse object graphs-Info'!

PackageInfo subclass: #MaTraverseObjectGraphsPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma traverse object graphs-Info'!

!MaTraverseObjectGraphsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2003 11:54'!
prerequisitePackages

	^#('Ma proxy support')! !

!Dictionary methodsFor: '*ma traverse object graphs' stamp: 'cmm 12/2/2004 17:29'!
maGraphDo: aBlock using: aObjectTraversalStrategy path: path with: alreadyVisitedSet

	| varIndex |

	varIndex := 1.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		[ : obj |
			self
				maValueGraphNode: obj
				index: varIndex
				using: aObjectTraversalStrategy
				with: aBlock
				path: path
				with: alreadyVisitedSet.
			varIndex := varIndex + 1 ]
				value: eachKey;
				value: eachValue ]! !

!Object methodsFor: '*ma traverse object graphs' stamp: 'cmm 12/2/2004 17:29'!
maGraphDo: threeArgBlock using: anObjectTraversalStrategy
	"Walk the receiver and all of its variables valuing threeArgBlock.  The first argument is an OrderedCollection of the objects leading to the current object, including the current object, the second argument is the parent of the current object (second to last in the path).  The third argument is the index or key object required to send instVarAt: to access the current object (except for Dictionaries, in which the key may not be an Integer.  All arguments are in their substituted form."

	nil
		maValueGraphNode: self 
		index: 0
		using: anObjectTraversalStrategy 
		with: threeArgBlock
		path: OrderedCollection new 
		with: IdentitySet new! !

!Object methodsFor: '*ma traverse object graphs' stamp: 'cmm 12/2/2004 17:28'!
maValueGraphNode: anObject index: anInteger using: aObjectTraversalStrategy with: aBlock path: path with: alreadyVisitedSet

	| stepInto |

	anObject == nil ifTrue: [ ^anObject ].
	anObject maIsMinimalObject ifTrue: [ ^anObject ].  "Never traverse or value a proxy.."
	(alreadyVisitedSet includes: anObject) ifTrue: [ ^anObject ].
	path add: anObject.
	stepInto :=
		aObjectTraversalStrategy
			shouldTraverseIntoLastOf: path
			from: self
			index: anInteger.
	(aObjectTraversalStrategy
		shouldValueLastOf: path
		from: self
		index: anInteger)
			ifTrue:
				[ alreadyVisitedSet add: anObject.  "IMPORTANT, this needs to be here and not above.."
				aBlock
					value: path
					value: self
					value: anInteger ].
	stepInto
		ifTrue:
			[ anObject
				maGraphDo: aBlock
				using: aObjectTraversalStrategy
				path: path
				with: alreadyVisitedSet ].
	path removeLast! !

!Object methodsFor: '*ma traverse object graphs' stamp: 'cmm 12/2/2004 17:29'!
maGraphDo: aBlock using: aObjectTraversalStrategy path: path with: alreadyVisitedSet
	"If this implementation changes, be sure to check subclasses below Collection which needed to copy this implementation."
	1
		to: self maInstSize
		do:
			[ :varIndex |
			self
				maValueGraphNode: (self instVarAt: varIndex)
				index: varIndex
				using: aObjectTraversalStrategy
				with: aBlock
				path: path
				with: alreadyVisitedSet ]
! !

!Object methodsFor: '*ma traverse object graphs' stamp: ''!
maGraphDo: threeArgBlock

	self
		maGraphWhere: [ :path :parent :index | true ]
		do: threeArgBlock
! !

Object subclass: #MaObjectGraphTraversalStrategy
	instanceVariableNames: 'valueWhenBlock traverseWhenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma traverse object graphs-API'!

!MaObjectGraphTraversalStrategy methodsFor: 'testing' stamp: ''!
shouldValueLastOf: anOrderedCollection from: parentObject index: anInteger

	^valueWhenBlock
		value: anOrderedCollection
		value: parentObject
		value: anInteger
! !

!MaObjectGraphTraversalStrategy methodsFor: 'building' stamp: ''!
valueWhen: threeArgBlock
	"The default behavior is to value every node once (the framework automatically
	keeps track of where it has already been).   threeArgBlock takes the same arguments
	as the other parameters of this class."

	valueWhenBlock := threeArgBlock
! !

!MaObjectGraphTraversalStrategy methodsFor: 'private' stamp: 'cmm 11/10/2004 23:02'!
initialize

	valueWhenBlock := [ :path :parent :instVarIndex | true ].
	traverseWhenBlock := [ :path :parent :instVarIndex | true ]! !

!MaObjectGraphTraversalStrategy methodsFor: 'building' stamp: ''!
traverseWhen: threeArgBlock
	"The default traversal behavior is to traverse everything.  threeArgBlock
	may be specified to restrict the default traversal (stepping into an objects
	instance variables).  The first argument is an OrderedCollection of the
	path of objects that lead to the current node, the second is the parent
	of the current node (and second to last in the path), the last is the integer
	index of the instVar of the current node."

	traverseWhenBlock := threeArgBlock
! !

!MaObjectGraphTraversalStrategy methodsFor: 'testing' stamp: ''!
shouldTraverseIntoLastOf: path from: parent index: anInteger

	^traverseWhenBlock
		value: path
		value: parent
		value: anInteger
! !

!MaObjectGraphTraversalStrategy class methodsFor: 'creation' stamp: 'cmm 1/21/2003 23:57'!
new

	^super new initialize! !

!Object methodsFor: '*ma traverse object graphs' stamp: 'cmm 1/21/2003 11:56'!
maGraphWhere: threeArgConditionBlock do: threeArgBlock

	| strategy |

	strategy := MaObjectGraphTraversalStrategy new traverseWhen: threeArgConditionBlock.
	self
		maGraphDo: threeArgBlock
		using: strategy
! !

!Set methodsFor: '*ma traverse object graphs' stamp: 'cmm 12/2/2004 17:29'!
maGraphDo: aBlock using: aObjectTraversalStrategy path: path with: alreadyVisitedSet
	"Sets and Dictionary's are enumerated logically."
	| varIndex |
	varIndex _ 1.
	self do:
		[ :each |
		self
			maValueGraphNode: each
			index: varIndex
			using: aObjectTraversalStrategy
			with: aBlock
			path: path
			with: alreadyVisitedSet.
		varIndex _ varIndex + 1 ]! !
